/*
 * Copyright (C) 2010-2011 Sébastien Villemot <sebastien.villemot@ens.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _MULTI_COUNTRY_HYB_SOLUTION_HH
#define _MULTI_COUNTRY_HYB_SOLUTION_HH

#include "PerSolution.hh"
#include "MultiCountryRBCA2.hh"

class MultiCountryHybSolution : public PerSolution
{
public:
  enum hybrid_t { PlainPerturbation, Hybrid };
  //! Number of countries
  const int n;
private:
  hybrid_t hybrid;
protected:
  virtual void policy_func_internal(const gsl_vector *y_prev, const gsl_vector *shocks, gsl_vector *y_curr);
public:
  MultiCountryHybSolution(const MultiCountryRBCA2 &modspec_arg, int order_arg, hybrid_t hybrid_arg) throw (UnsupportedSpec);
  virtual ~MultiCountryHybSolution();
  virtual std::string name() const;
  static std::string matname(const MultiCountryRBCA2 &modspec, int order);
  virtual void create_state_vector(const gsl_vector *y_prev, const gsl_vector *shocks, gsl_vector *state) const;
  virtual void reorder_from_dynare(const gsl_vector *y_dynare, gsl_vector *y_curr) const;
};

#endif // !_MULTI_COUNTRY_HYB_SOLUTION_HH
